#! /bin/sh
#
# urandom	This script saves the random seed between reboots.
#		It is called from the boot, halt and reboot scripts.
#
# Version:	@(#)urandom  1.33  22-Jun-1998  miquels@cistron.nl
#

[ -c /dev/urandom ] || exit 0

RANDOM_SEED_FILE="/opt/userdata/random-seed"

case "$1" in
	start|"")
		if [ "$VERBOSE" != no ]
		then
			printf "Initializing random number generator... "
		fi
		# Load and then save 512 bytes,
		# which is the size of the entropy pool
		if [ -f ${RANDOM_SEED_FILE} ]
		then
			cat ${RANDOM_SEED_FILE} >/dev/urandom
		fi
		# check for read only file system
		if ! touch ${RANDOM_SEED_FILE} 2>/dev/null
		then
			printf "read-only file system detected...done\\n"
			exit
		fi
		rm -f ${RANDOM_SEED_FILE}
		umask 077
		dd if=/dev/urandom of=${RANDOM_SEED_FILE} count=1 \
			>/dev/null 2>&1 || printf "urandom start: failed.\\n"
		umask 022
		[ "$VERBOSE" != no ] && printf "done.\\n"
		;;
	stop)
		if ! touch ${RANDOM_SEED_FILE} 2>/dev/null
		then
			exit
		fi
		# Carry a random seed from shut-down to start-up;
		# see documentation in linux/drivers/char/random.c
		[ "$VERBOSE" != no ] && printf "Saving random seed... "
		umask 077
		dd if=/dev/urandom of=${RANDOM_SEED_FILE} count=1 \
			>/dev/null 2>&1 || printf "urandom stop: failed.\\n"
		[ "$VERBOSE" != no ] && printf "done.\\n"
		;;
	*)
		printf "Usage: urandom {start|stop}\\n" >&2
		exit 1
		;;
esac
